mod = 998244353

MAXL = 111
p10 = [1]
for i in range(1,MAXL):
    p10.append(p10[-1]*10 % mod)

def pos(num):
    res = 0
    for i in range(1,len(num)):
        res += i * (p10[i] - p10[i-1]) % mod
    a = (int(num) - p10[len(num)-1]) % mod
    return (res + a * len(num)) % mod

def match_single(a,b,startb):
    for i in range(len(a)):
        c1,c2 = a[i],("?" if startb+i >= len(b) else b[startb+i])
        if c1 != "?" and c2 != "?" and c1 != c2:
            return False
    return True

def pad(num,length):
    return "0"*(length-len(str(num))) + str(num)

def add_one(s):
    ns = list(s)
    for i in range(len(ns)-1,-1,-1):
        if ns[i] == "9":
            ns[i] = "0"
        else:
            ns[i] = str(int(ns[i])+1)
            break
    else:
        ns.insert(0,"1")
    return "".join(ns)

def matches(prefix,text,want):
    left = want - len(prefix)
    if left == 0:
        curp = 0
        c = prefix
        while curp < len(text):
            if not match_single(c,text,curp):
                return None
            curp += len(c)
            c = add_one(c)
        return prefix
    
    if left <= 2:
        for i in range(10**left):
            test = prefix + pad(i,left)
            if matches(test,text,want):
                return test
        return None

    nums = 0
    curp = 0
    while curp < len(text):
        if not match_single(prefix,text,curp):
            return matches(prefix + "9"*(left-2), text, want)
        nums += 1
        curp += len(prefix) + left
    return prefix

def get_offset(nlen,offset,text):
    text = "?"*offset + text
    if nlen <= 2:
        for i in range(10**(nlen-1), 10**nlen):
            if matches(str(i),text,nlen):
                return str(i)
        return None
    curs = ""
    while len(curs) < nlen:
        for d in range(1 if len(curs) == 0 else 0, 10):
            if res := matches(curs+str(d),text,nlen):
                curs = res
                break
        else:
            for i in range(1,len(curs)+1):
                test = curs[:-i] + "9"*(nlen-(len(curs)-i)-2)
                if res := matches(test,text,nlen):
                    return res
            return None
    return curs


def solve(s):
    for digits in range(1,len(s)+2):
        best = None
        for offset in range(digits):
            cur = get_offset(digits,offset,s)
            if cur is not None and (best is None or cur < best[0]):
                best = (cur, offset)
        if best is not None:
            return pos(best[0]) + best[1]

n = int(input())
for _ in range(n):
    print((solve(input())+1) % mod)
